#!/usr/bin/env python
# -*- coding: UTF-8 -*-

#Se importan las librerias necesarias
import sys
import pygtk
pygtk.require("2.0")
import gtk.glade, os, string
import shutil
import pwd



class Diagnostico:
        def __init__(self):
        	#Declara la interfaz gráfica
		self.gladefile = "/usr/bin/cga-herramienta-informacion.glade"
		self.wTree = gtk.glade.XML(self.gladefile)		
		#Llama al procedimiento para crear el archivo vacío.
		self.crear_fichero()
		

	#Diccionario
		dic = {"on_btnactualizar_clicked" : self.btnactualizar_clicked,
			"on_btnguardararchivo_clicked" : self.btnguardararchivo_clicked,
			"on_btnguardar_clicked" : self.btnguardar_clicked,
			"on_btncancelar_clicked" : self.btncancelar_clicked,
			"on_btnactdatos_clicked" : self.btnactdatos_clicked,
			"on_btnsalir_clicked" : self.salir,
			"on_vPrincipal_delete_event" : self.cerrar
		}
		

	#Ventanas
		self.filechooserdialog = self.wTree.get_widget("filechooserdialog1")
		self.principal = self.wTree.get_widget("vPrincipal")

	#Treeview
		self.treeview_general = self.wTree.get_widget("treeview_general")
		self.treeview_red = self.wTree.get_widget("treeview_red")
		self.treeview_hardware = self.wTree.get_widget("treeview_hardware")
		self.treeview_perifericos = self.wTree.get_widget("treeview_perifericos")
		self.treeview_software = self.wTree.get_widget("treeview_software")
		self.notebook = self.wTree.get_widget("notebook1")

	#Botones
		self.btnactualizar = self.wTree.get_widget("btnactualizar")
		self.btnguardar = self.wTree.get_widget("btnguardar")
		self.btnactdatos = self.wTree.get_widget("btnactdatos")
		self.btncancelar = self.wTree.get_widget("btncancelar")
		self.btnguardararchivo = self.wTree.get_widget("btnbtnguardararchivo")
		

	#se conecta cada señal con la función manejadora		
		self.wTree.signal_autoconnect(dic)


	#Construye treeview y presenta pantalla principal
		self.construir_treeview()
		gtk.window_set_default_icon_from_file("/usr/share/pixmaps/cga-herramienta-informacion.png")
#		self.principal.set_icon_from_file("/usr/share/pixmaps/cga-herramienta-informacion.png")
		self.principal.show()
	
	
	#Crea el archivo vacío donde se guardará la información
	def crear_fichero(self):
		f = open("/tmp/Información del Sistema.txt","w")
		f.close()


	#Al presionar este botón se actualizarán los datos de cada treeview y el foco va a la primera página del notebook
	def btnactdatos_clicked(self, widget,data=None):
		self.btnactdatos.set_sensitive(False)
		self.destruir_treestore()
		self.crear_fichero()
		self.general()
		self.red()
		self.hardware()	
		self.perifericos()
		self.software()
		self.principal.show()
		self.notebook.set_current_page(0)
		self.btnactdatos.set_sensitive(True)
		
		
	#Llama a la aplicación cga-actualizacion
	def btnactualizar_clicked(self, widget,data=None):
		os.popen("/usr/bin/cga-actualizacion")

	
	#Presenta por pantalla la ventana para guardar el archivo en la ruta que queramos
	def btnguardararchivo_clicked(self, widget,data=None):
		self.filechooserdialog.show()
	
	
	#Después de elegir la ruta y el nombre del archivo para guardar, al pulsar botón "Guardar"
	# hace una copia del archivo ya creado incialmente en la ruta marcada
	def btnguardar_clicked(self, widget,data=None):
		shutil.copy("/tmp/Información del Sistema.txt", self.filechooserdialog.get_filename())
		uid_usuario = pwd.getpwnam(sys.argv[1])[2]
                uid_grupo = pwd.getpwnam(sys.argv[1])[3]
                os.chown(self.filechooserdialog.get_filename(),uid_usuario,uid_grupo)
		self.filechooserdialog.hide()
		
		
	#Oculta la venta de guardar archivo	
	def btncancelar_clicked(self, widget,data=None):
		self.filechooserdialog.hide()
	
	
	#Función a la q le pasamos un comando y nos devuelve el resultado en una lista con lo que saldría por terminal
	def leer_salida(self, comando):
    		stdin, var = os.popen4(comando)
    		datos=[]
    		for line in var.readlines():
        		datos.append(line)
    		return datos
    		
    	
    	#Para iniciar los treestore
    	def destruir_treestore(self):
    		self.treestore_general.clear()
		self.treestore_red.clear()
		self.treestore_hardware.clear()
		self.treestore_software.clear()
		self.treestore_perifericos.clear()
	
	
	#Construye los treeview
	def construir_treeview(self):
		
		#declaro lista
		milistado=[]
		
		#Creo los treestore con una columna de cadena
        	self.treestore_general = gtk.TreeStore(str)
		self.treestore_red = gtk.TreeStore(str)
		self.treestore_hardware = gtk.TreeStore(str)
		self.treestore_software = gtk.TreeStore(str)
		self.treestore_perifericos = gtk.TreeStore(str)
	

		#Creo los treeview usando treestore
		self.treeview_general.set_model(self.treestore_general)
		self.treeview_red.set_model(self.treestore_red)
		self.treeview_hardware.set_model(self.treestore_hardware)
		self.treeview_perifericos.set_model(self.treestore_perifericos)
		self.treeview_software.set_model(self.treestore_software)
	
		
		#Creo los TreeViewColumn para mostrar los datos
		self.tvcolumn_general = gtk.TreeViewColumn('')
		self.tvcolumn_red = gtk.TreeViewColumn('')
		self.tvcolumn_hardware = gtk.TreeViewColumn('')
		self.tvcolumn_perifericos = gtk.TreeViewColumn('')
		self.tvcolumn_software = gtk.TreeViewColumn('')
	

		#Añado tvcolumn a treeview
		self.treeview_general.append_column(self.tvcolumn_general)
		self.treeview_red.append_column(self.tvcolumn_red)
		self.treeview_hardware.append_column(self.tvcolumn_hardware)
		self.treeview_perifericos.append_column(self.tvcolumn_perifericos)
		self.treeview_software.append_column(self.tvcolumn_software)


		#Creo los CellRendererText para procesar los datos
		self.cell_general = gtk.CellRendererText()
		self.cell_red = gtk.CellRendererText()
		self.cell_hardware = gtk.CellRendererText()
		self.cell_perifericos = gtk.CellRendererText()
		self.cell_software = gtk.CellRendererText()

		
		#Añado los cell para cada tvcolumn y para que pueda expandirse
		self.tvcolumn_general.pack_start(self.cell_general, True)
		self.tvcolumn_red.pack_start(self.cell_red, True)
		self.tvcolumn_hardware.pack_start(self.cell_hardware, True)
		self.tvcolumn_perifericos.pack_start(self.cell_perifericos, True)
		self.tvcolumn_software.pack_start(self.cell_software, True)

		
		#Establece los cell de la columna 0 y recupera el texto
		#de cada columna en treestore
		self.tvcolumn_general.add_attribute(self.cell_general, 'text', 0)
		self.tvcolumn_red.add_attribute(self.cell_red, 'text', 0)
		self.tvcolumn_hardware.add_attribute(self.cell_hardware, 'text', 0)
		self.tvcolumn_perifericos.add_attribute(self.cell_perifericos, 'text', 0)
		self.tvcolumn_software.add_attribute(self.cell_software, 'text', 0)



		#Lama a cada procedimiento para rellenar los treestore
		self.general()
		self.red()
		self.hardware()	
		self.perifericos()
		self.software()
		
		
	#Procedimiento que va añadiendo información al archivo
	def informe(self, datos):
		f = open("/tmp/Información del Sistema.txt","a")
		f.write(datos+"\n")
		f.close()

	
	def general(self):
		########### GENERAL ############
		self.informe("*** INFORMACION GENERAL ***")
		
		#Escuela 2.0
		escuela = ""
                comando="dpkg -l |grep -i guadalinexedu-educacion-aula20 |cut -d' ' -f3"
                milistado=self.leer_salida(comando)
                if milistado:
                       escuela = "Escuela 2.0"


		#Distribución
		comando="lsb_release -cs"
                milistado=self.leer_salida(comando)
                for linea in milistado:
                        if str(linea[:-1]) == "lucid":#"2.6.32-23-generic":
                                comando="dpkg -l|grep guadalinexedu-dom-app-install-data"
                                milistado=self.leer_salida(comando)
                                if milistado:
                                        piter_general = self.treestore_general.append(None, ['Distribución: Guadalinex Edu 10.04 versión doméstica'])
                                        self.informe("-Distribución: Guadalinex Edu 10.04 versión doméstica")
                                else:
                                        piter_general = self.treestore_general.append(None, ['Distribución: Guadalinex Edu 10.04 Centros Educativos '+ escuela])
                                        self.informe("-Distribución: Guadalinex Edu 10.04 Centros Educativos "+ escuela)
                        elif str(linea[:-1]) == "jaunty":#"2.6.28-16-generic":
                                comando="dpkg -l|grep guadalinex-meta"
                                milistado=self.leer_salida(comando)
                                if milistado:
                                        piter_general = self.treestore_general.append(None, ['Distribución: Guadalinex Edu 10.04 versión doméstica'])
                                        self.informe("-Distribución: Guadalinex Edu 9.04 versión doméstica")
                                else:
                                        piter_general = self.treestore_general.append(None, ['Distribución: Guadalinex Edu 9.04 Centros Educativos '+ escuela])
                                        self.informe("-Distribución: Guadalinex Edu 9.04 Centros Educativos "+ escuela)
                        
                        else:
                                piter_general = self.treestore_general.append(None, ['Distribución: desconocida'])
                                self.informe("-Distribución: desconocida")

                        break
	
		

		#Usuario		
		piter_general = self.treestore_general.append(None, ['Usuario autenticado: '+sys.argv[1]])
		self.informe("-Usuario autenticado: "+sys.argv[1]) 		

		
		
		#Dual
		comando="fdisk -l |grep NTFS"
		milistado=self.leer_salida(comando)		
			
		if milistado:
			piter_general = self.treestore_general.append(None, ['El equipo es dual'])
			self.informe("-El equipo es dual")



	def red(self):
		########### RED ############
		self.informe("\n*** RED ***")
		#Contar cuantas redes hay conectadas
		comando1="ifconfig |grep -c Ethernet |cut -d' ' -f1"
		milistado1=self.leer_salida(comando1)
		#Nombre de red(eth0,wlan0,...)
		comando2="ifconfig |grep Ethernet |cut -d' ' -f1"
		milistado2=self.leer_salida(comando2)
		#Mientras milistado1 de redes conectadas sea mayor que 0
		if int(milistado1[0]) > 0:
			contador = int(milistado1[0])
			#Mientras contador sea mayor 0
			while contador > 0:
				contador = contador -1
				
				piter_red = self.treestore_red.append(None, ['** '+str(milistado2[contador].rstrip())+' **'])			
				self.informe("* "+str(milistado2[contador].rstrip())+" *")
				#IP
				comando="ifconfig "+str(milistado2[contador].rstrip())+" |grep -i Direc.\ \inet|cut -d':' -f2|cut -d 'D' -f1"
				milistado=self.leer_salida(comando)
				if milistado:
					for linea in milistado:
						piter_red_hijo = self.treestore_red.append(piter_red, ['Dirección IP: '+linea[:-1]])
						self.informe("-Dirección IP: "+linea[:-1])
				else:
					piter_red_hijo = self.treestore_red.append(piter_red, ['Dirección IP: No tiene ip asignada'])
					self.informe("-Dirección IP: No tiene ip asignada")
				
				#Máscara
				comando="ifconfig "+str(milistado2[contador].rstrip())+" |grep -i Másc|cut -d':' -f4"
				milistado=self.leer_salida(comando)		
				if milistado:
					for linea in milistado:
						piter_red_hijo = self.treestore_red.append(piter_red, ['Máscara de red: '+linea[:-1]])
						self.informe("-Máscara de red: "+linea[:-1])
				else:
					piter_red_hijo = self.treestore_red.append(piter_red, ['Máscara de red: No tiene máscara asignada'])
					self.informe("-Máscara de red: No tiene máscara asignada")
	
				#MAC
				comando="ifconfig "+str(milistado2[contador].rstrip())+"|grep -i direcciónHW|cut -d'W' -f2"
				milistado=self.leer_salida(comando)		
				for linea in milistado:
					piter_red_hijo = self.treestore_red.append(piter_red, ['Dirección MAC: '+linea[:-1]])		
					self.informe("-Dirección MAC: "+linea[:-1])

				#Comprueba si la red esta conectada por cable o wifi
				comando="cat /proc/net/wireless |grep "+str(milistado2[contador].rstrip())
				milistado=self.leer_salida(comando)
				if milistado:
					piter_red_hijo = self.treestore_red.append(piter_red, ['Conexión habilitada por wifi'])
					self.informe("-Conexión habilitada por wifi")
					#Si es por wifi busca el ESSID de la red
					comando="iwconfig "+str(milistado2[contador].rstrip())+" |grep ESSID:| cut -d':' -f2"
					milistado=self.leer_salida(comando)
					for linea in milistado:
						if str(linea[1:-4].rstrip()):
							piter_red_hijo = self.treestore_red.append(piter_red, ['ESSID: '+linea[1:-4]])
							self.informe("-ESSID: "+linea[1:-4])
						else:
							piter_red_hijo = self.treestore_red.append(piter_red, ['ESSID: No esta conectado a ninguna red wifi'])							
							self.informe("-ESSID: No esta conectado a ninguna red wifi")
				else:
					piter_red_hijo = self.treestore_red.append(piter_red, ['Conexión habilitada por cable'])
					self.informe("-Conexión habilitada por cable")
				
				#Subred a la que pertenece
				comando="ifconfig "+str(milistado2[contador].rstrip())+"|grep -i Direc.\ \inet|cut -d'.' -f4"
				milistado=self.leer_salida(comando)
				if milistado:
					for linea in milistado:
						if int(linea[:-1]) >=0 and int(linea[:-1]) <=3:
							piter_red_hijo = self.treestore_red.append(piter_red, ['Subred: Alumno'])
							self.informe("-Subred: Alumno")
						elif int(linea[:-1]) >=4 and int(linea[:-1]) <=5:
							piter_red_hijo = self.treestore_red.append(piter_red, ['Subred: Gestión'])
							self.informe("-Subred: Gestión")
						elif int(linea[:-1]) >=6 and int(linea[:-1]) <=7:
							piter_red_hijo = self.treestore_red.append(piter_red, ['Subred: Profesor'])
							self.informe("-Subred: Profesor")
						else:
							piter_red_hijo = self.treestore_red.append(piter_red, ['Subred: desconocida'])
							self.informe("-Subred: desconocida")
						break
				else:
					piter_red_hijo = self.treestore_red.append(piter_red, ['Subred: Al no tener ip asignada no se sabe a que subred pertenece'])
					self.informe("-Subred: Al no tener ip asignada no se sabe a que subred pertenece")




				#Si posee infraestructuras TIC
                                piter_red_hijo = self.treestore_red.append(piter_red, ['Infraestructura TIC'])
                                comando="ping -c 1 f0 |grep -i received |cut -d',' -f2"
                                milistado=self.leer_salida(comando)
                                if str(milistado[0].rstrip()) == " 1 received":
                                        self.informe("-Infraestructura TIC: ")
                                        self.treestore_red.append(piter_red_hijo, ['f0'])
                                        self.informe("f0")
                                        comando="ping -c 1 c0 |grep -i received |cut -d',' -f2"
                                        milistado=self.leer_salida(comando)
                                        if str(milistado[0].rstrip()) == " 1 received":
                                                self.treestore_red.append(piter_red_hijo, ['c0'])
                                                self.informe("c0")
                                else:
                                        self.treestore_red.append(piter_red_hijo, ['No se ha encontrado ninguna infraestructura TIC'])
                                        self.informe("-Infraestructura TIC: No se ha encontrado ninguna infraestructura TIC")





	def hardware(self):	
		########### HARDWARE ############		
		self.informe("\n*** HARDWARE ***")
		piter_hardware = self.treestore_hardware.append(None, ['Placa base'])
		self.informe("-Placa Base: ")
		#Nombre, serial, fabricante y versión de la placa base
		comando="sudo cat /sys/class/dmi/id/board_name /sys/class/dmi/id/board_serial /sys/class/dmi/id/board_vendor /sys/class/dmi/id/board_version"
		milistado=self.leer_salida(comando)		
		for linea in milistado:
			if str(linea[:-1].rstrip()):
				self.treestore_hardware.append(piter_hardware, [linea[:-1]])			
				self.informe(linea[:-1])
 

		piter_hardware = self.treestore_hardware.append(None, ['Tarjeta gráfica'])
		self.informe("-Tarjeta gráfica: ")
		#Tarjetas gráficas
		comando="lspci |grep -i VGA\ \compatible\ \controller:|cut -d':' -f3"
		milistado=self.leer_salida(comando)		
		for linea in milistado:
			if str(linea[:-1].rstrip()):
				self.treestore_hardware.append(piter_hardware, [linea[:-1]])
				self.informe(linea[:-1])
		
		piter_hardware = self.treestore_hardware.append(None, ['Tarjeta de red'])
		self.informe("-Tarjeta de red: ")
		#Tarjetas de red
		comando="lspci |grep -i Ethernet\ \controller:|cut -d':' -f3 && lspci|grep -i Network\ \controller:|cut -d':' -f3"
		milistado=self.leer_salida(comando)		
		for linea in milistado:
			if str(linea[:-1].rstrip()):
				self.treestore_hardware.append(piter_hardware, [linea[:-1]])			
				self.informe(linea[:-1])


		piter_hardware = self.treestore_hardware.append(None, ['Tarjeta de sonido'])
		self.informe("-Tarjeta de sonido: ")
		#Tarjetas de sonido
		comando="lspci |grep -i Audio\ \device:|cut -d':' -f3"
		milistado=self.leer_salida(comando)		
		for linea in milistado:
			if str(linea[:-1].rstrip()):
				self.treestore_hardware.append(piter_hardware, [linea[:-1]])
				self.informe(linea[:-1])

		
		piter_hardware = self.treestore_hardware.append(None, ['Disco duro'])
		self.informe("-Disco duro: ")
		#Disco duro
		comando="sudo lshw | grep -A 11 disk"
		milistado=self.leer_salida(comando)		
		for linea in milistado:
			if str(linea[:-1].rstrip()):
				self.treestore_hardware.append(piter_hardware, [linea[:-1]])
				self.informe(linea[:-1])

		
	def perifericos(self):
		########### PERIFERICOS ############
                self.informe("\n*** PERIFERICOS ***")
                piter_perifericos = self.treestore_perifericos.append(None, ['Pizarra digital Smartboard'])
                self.informe("-Pizarra digital Smartboard:")
                #Busca si esta instalado el meta de smartboard
                comando="dpkg -l |grep -i smartboard-meta|cut -d' ' -f3"
                milistado=self.leer_salida(comando)
                if milistado:
                        self.treestore_perifericos.append(piter_perifericos, ['Se ha detectado software'])
                        self.informe("Se ha detectado software")
                else:
                        self.treestore_perifericos.append(piter_perifericos, ['No se detecta software'])
                        self.informe("No se detecta software")

                #Busca si se encuentra conectada al equipo 
                comando="lsusb |grep 0b8c:0001"
                milistado=self.leer_salida(comando)
                if milistado:
                        self.treestore_perifericos.append(piter_perifericos, ['Está conectada'])
                        self.informe("Está conectada")
                else:
                	comando="lsusb |grep 0b8c:0061"
	                milistado=self.leer_salida(comando)
        	        if milistado:
                	        self.treestore_perifericos.append(piter_perifericos, ['Está conectada'])
                        	self.informe("Está conectada")
	                else:
        	                self.treestore_perifericos.append(piter_perifericos, ['No está conectada'])
                	        self.informe("No está conectada")

		

		piter_perifericos = self.treestore_perifericos.append(None, ['Pizarra digital Promethean'])
                self.informe("-Pizarra digital Promethean:")
                #Lo mismo con promethean
                comando="dpkg -l |grep -i promethean-meta|cut -d' ' -f3"
                milistado=self.leer_salida(comando)
                if milistado:
                        self.treestore_perifericos.append(piter_perifericos, ['Se ha detectado software'])
                        self.informe("Se ha detectado software")
                else:
                        self.treestore_perifericos.append(piter_perifericos, ['No se detecta software'])
                        self.informe("No se detecta software")


                comando="lsusb |grep 05e3:0607"
                milistado=self.leer_salida(comando)
                if milistado:
                        self.treestore_perifericos.append(piter_perifericos, ['Está conectada'])
                        self.informe("Está conectada")
                else:
                        self.treestore_perifericos.append(piter_perifericos, ['No está conectada'])
                        self.informe("No está conectada")

		
		
		
		piter_perifericos = self.treestore_perifericos.append(None, ['Impresoras'])
		self.informe("-Impresoras: ")
		#Si existe el fichero printers.conf
		if os.path.exists("/etc/cups/printers.conf"):
                        #Busca el número total de impresoras
                        comando1="sudo cat /etc/cups/printers.conf |grep  -c Info | cut -d' ' -f2,3,4"
                        milistado=self.leer_salida(comando1)
                        contador_impr = int(milistado[0])
                        #Busca todas las impresoras configuradas en el equipo
                        comando2="sudo cat /etc/cups/printers.conf |grep  -i Info | cut -d' ' -f2,3,4"
                        milistado=self.leer_salida(comando2)
                        if milistado:
                                for linea in milistado:
                                        if str(linea[:-1].rstrip()) != "PDF":
                                                self.treestore_perifericos.append(piter_perifericos, [linea[:-1]])
                                                self.informe(linea[:-1])
                                        elif str(linea[:-1].rstrip()) == "PDF" and contador_impr == 1:
                                                piter_perifericos = self.treestore_perifericos.append(piter_perifericos, ['No hay impresoras configuradas'])
                                                self.informe("No hay impresoras configuradas")
                        else:
                                piter_perifericos = self.treestore_perifericos.append(piter_perifericos, ['No hay impresoras configuradas'])
                                self.informe("No hay impresoras configuradas")
                else:
                        piter_perifericos = self.treestore_perifericos.append(piter_perifericos, ['No hay impresoras configuradas'])
                        self.informe("No hay impresoras configuradas")
	
		
		piter_perifericos = self.treestore_perifericos.append(None, ['Dispositivos USB'])	
		self.informe("-Dispositivos USB: ")
		#Busca los dispositivos usb conectados al equipo
		comando="lsusb |grep -v  Linux|cut -d' ' -f6"
		milistado=self.leer_salida(comando)
		if milistado:
			for linea_id in milistado:
				#Busca el nombre del dispositivo
				comando="lsusb |grep "+str(linea_id[:-1].rstrip())+"|cut -d' ' -f7-20"
				milistado=self.leer_salida(comando)			
				for linea_nombre in milistado:
					if str(linea_nombre[:-1].rstrip()):
						#Busco el tipo de dispositivo que es	
						comando="sudo lsusb -v -d "+linea_id[:-1]+" |grep -m 1 iProduct |cut -d' ' -f20-50"
						milistado=self.leer_salida(comando)
						for linea in milistado:
							#Esta cadena aparece en los pendrives y los hd externos, si no encuentra la cadena, entra en el if
							if int(linea[:-1].find("Connection timed out")) == -1:
								self.treestore_perifericos.append(piter_perifericos, [linea_nombre[:-1]+", "+linea[:-1]])
								self.informe(linea_nombre[:-1]+", "+linea[:-1])
					else:
						#Busco el tipo de dispositivo que es	
						comando="sudo lsusb -v -d "+linea_id[:-1]+" |grep -m 1 iProduct |cut -d' ' -f20-50"
						milistado=self.leer_salida(comando)
						for linea in milistado:
							#Esta cadena aparece en los pendrives y los hd externos, si no encuentra la cadena, entra en el if
							if int(linea[:-1].find("Connection timed out")) == -1:
								self.treestore_perifericos.append(piter_perifericos, ['Dispositivo desconocido, '+linea[:-1]])
								self.informe('Dispositivo desconocido, '+linea[:-1])
		else:
			self.treestore_perifericos.append(piter_perifericos, ['No hay dispositivos USB conectados al equipo'])
			self.informe("No hay dispositivos USB conectados al equipo")

	def software(self):
		
		########### SOFTWARE ############
		self.informe("\n*** SOFTWARE ***")
		correcto = True
		#Busca los paquetes que no se han podido borrar archivos de configuración
		comando="dpkg -l |grep ^.f |cut -d ' ' -f3"
		milistado=self.leer_salida(comando)		
		if milistado:
			Correcto = False
			piter_software = self.treestore_software.append(None, ['Paquetes que no se han podido borrar archivos de configuración'])
			self.informe("-Paquetes que no se han podido borrar archivos de configuración: ")
			for linea in milistado:
				self.treestore_software.append(piter_software, [linea[:-1]])
				self.informe(linea[:-1])
				
		#Busca los paquetes que están parcialmente instalados
		comando="dpkg -l |grep ^.h |cut -d ' ' -f3"
		milistado=self.leer_salida(comando)		
		if milistado:
			Correcto = False
			piter_software = self.treestore_software.append(None, ['Paquetes parcialmente instalados'])
			self.informe("-Paquetes parcialmente instalados: ")
			for linea in milistado:
				self.treestore_software.append(piter_software, [linea[:-1]])
				self.informe(linea[:-1])
		#Si no encuentra nada
		if correcto == True:
			piter_software = self.treestore_software.append(None, ['No se presentan inconsistencias en el software del equipo'])
			self.informe("No se presentan inconsistencias en el software del equipo")


	#Salir de la aplicacion
	def salir (self, widget,data=None):
		self.principal.hide()
		gtk.main_quit()		
			
	def cerrar (self, widget,data=None):
		self.principal.hide()
		gtk.main_quit()
		


if __name__ == "__main__":
	Ogui = Diagnostico()
	gtk.main()
